CREATE TABLE fa_distribution_history (
    DISTRIBUTION_ID              NUMBER(18, 0),
    BOOK_TYPE_CODE               VARCHAR2(120),
    ASSET_ID                     NUMBER(18, 0)    NOT NULL,
    UNITS_ASSIGNED               NUMBER           NOT NULL,
    TRANSACTION_UNITS            NUMBER       ,
    CODE_COMBINATION_ID          NUMBER(18, 0)    NOT NULL,
    LOCATION_ID                  NUMBER(18, 0),
    ASSIGNED_TO                  NUMBER(18, 0),
    TRANSACTION_HEADER_ID_IN     NUMBER(18, 0)    NOT NULL,
    TRANSACTION_HEADER_ID_OUT    NUMBER(18, 0),
    DATE_EFFECTIVE               DATE             NOT NULL,
    DATE_INEFFECTIVE             DATE         ,
    RETIREMENT_ID                NUMBER(18, 0),
    CREATION_DATE                TIMESTAMP(6)     NOT NULL,
    CREATED_BY                   VARCHAR2(256)    NOT NULL,
    LAST_UPDATE_DATE             TIMESTAMP(6)     NOT NULL,
    LAST_UPDATED_BY              VARCHAR2(256)    NOT NULL,
    LAST_UPDATE_LOGIN            VARCHAR2(128),
    OBJECT_VERSION_NUMBER        NUMBER(9, 0)     NOT NULL,
    INVENTORY_DATE_TAKEN         DATE         ,
    ATTRIBUTE_CATEGORY           VARCHAR2(120),
    ATTRIBUTE1                   VARCHAR2(600),
    ATTRIBUTE2                   VARCHAR2(600),
    ATTRIBUTE3                   VARCHAR2(600),
    ATTRIBUTE4                   VARCHAR2(600),
    ATTRIBUTE5                   VARCHAR2(600),
    ATTRIBUTE6                   VARCHAR2(600),
    ATTRIBUTE7                   VARCHAR2(600),
    ATTRIBUTE8                   VARCHAR2(600),
    ATTRIBUTE9                   VARCHAR2(600),
    ATTRIBUTE10                  VARCHAR2(600),
    ATTRIBUTE11                  VARCHAR2(600),
    ATTRIBUTE12                  VARCHAR2(600),
    ATTRIBUTE13                  VARCHAR2(600),
    ATTRIBUTE14                  VARCHAR2(600),
    ATTRIBUTE15                  VARCHAR2(600),
    ATTRIBUTE_NUMBER1            NUMBER       ,
    ATTRIBUTE_NUMBER2            NUMBER       ,
    ATTRIBUTE_NUMBER3            NUMBER       ,
    ATTRIBUTE_NUMBER4            NUMBER       ,
    ATTRIBUTE_NUMBER5            NUMBER       ,
    ATTRIBUTE_DATE1              DATE         ,
    ATTRIBUTE_DATE2              DATE         ,
    ATTRIBUTE_DATE3              DATE         ,
    ATTRIBUTE_DATE4              DATE         ,
    ATTRIBUTE_DATE5              DATE         ,
    DISTRIBUTION_ID              NUMBER(18, 0),
    BOOK_TYPE_CODE               VARCHAR2(120),
    ASSET_ID                     NUMBER(18, 0)    NOT NULL,
    UNITS_ASSIGNED               NUMBER           NOT NULL,
    TRANSACTION_UNITS            NUMBER       ,
    CODE_COMBINATION_ID          NUMBER(18, 0)    NOT NULL,
    LOCATION_ID                  NUMBER(18, 0),
    ASSIGNED_TO                  NUMBER(18, 0),
    TRANSACTION_HEADER_ID_IN     NUMBER(18, 0)    NOT NULL,
    TRANSACTION_HEADER_ID_OUT    NUMBER(18, 0),
    DATE_EFFECTIVE               DATE             NOT NULL,
    DATE_INEFFECTIVE             DATE         ,
    RETIREMENT_ID                NUMBER(18, 0),
    CREATION_DATE                TIMESTAMP(6)     NOT NULL,
    CREATED_BY                   VARCHAR2(256)    NOT NULL,
    LAST_UPDATE_DATE             TIMESTAMP(6)     NOT NULL,
    LAST_UPDATED_BY              VARCHAR2(256)    NOT NULL,
    LAST_UPDATE_LOGIN            VARCHAR2(128),
    OBJECT_VERSION_NUMBER        NUMBER(9, 0)     NOT NULL,
    INVENTORY_DATE_TAKEN         DATE         ,
    ATTRIBUTE_CATEGORY           VARCHAR2(120),
    ATTRIBUTE1                   VARCHAR2(600),
    ATTRIBUTE2                   VARCHAR2(600),
    ATTRIBUTE3                   VARCHAR2(600),
    ATTRIBUTE4                   VARCHAR2(600),
    ATTRIBUTE5                   VARCHAR2(600),
    ATTRIBUTE6                   VARCHAR2(600),
    ATTRIBUTE7                   VARCHAR2(600),
    ATTRIBUTE8                   VARCHAR2(600),
    ATTRIBUTE9                   VARCHAR2(600),
    ATTRIBUTE10                  VARCHAR2(600),
    ATTRIBUTE11                  VARCHAR2(600),
    ATTRIBUTE12                  VARCHAR2(600),
    ATTRIBUTE13                  VARCHAR2(600),
    ATTRIBUTE14                  VARCHAR2(600),
    ATTRIBUTE15                  VARCHAR2(600),
    ATTRIBUTE_NUMBER1            NUMBER       ,
    ATTRIBUTE_NUMBER2            NUMBER       ,
    ATTRIBUTE_NUMBER3            NUMBER       ,
    ATTRIBUTE_NUMBER4            NUMBER       ,
    ATTRIBUTE_NUMBER5            NUMBER       ,
    ATTRIBUTE_DATE1              DATE         ,
    ATTRIBUTE_DATE2              DATE         ,
    ATTRIBUTE_DATE3              DATE         ,
    ATTRIBUTE_DATE4              DATE         ,
    ATTRIBUTE_DATE5              DATE         ,
    CONSTRAINT pk_fa_distribution_history PRIMARY KEY (DISTRIBUTION_ID, BOOK_TYPE_CODE, DISTRIBUTION_ID, BOOK_TYPE_CODE)
);
